'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _vue = require('vue');

var _vue2 = _interopRequireDefault(_vue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var linkEventsAndPromise = function linkEventsAndPromise(instance, eventsList, type) {
  eventsList.forEach(function (v) {
    instance.$on(v, function (data) {
      type({
        type: v,
        data: data
      });
    });
  });
};

exports.default = function (opt) {
  var component = opt.component,
      _opt$resolveEvents = opt.resolveEvents,
      resolveEvents = _opt$resolveEvents === undefined ? [] : _opt$resolveEvents,
      _opt$rejectEvents = opt.rejectEvents,
      rejectEvents = _opt$rejectEvents === undefined ? [] : _opt$rejectEvents,
      el = opt.el,
      _opt$visibleProp = opt.visibleProp,
      visibleProp = _opt$visibleProp === undefined ? 'visible' : _opt$visibleProp;

  if (!el) {
    el = '#PC-EL-' + new Date().getTime();
    var elNode = document.createElement('div');
    elNode.id = el.slice(1);
    document.body.appendChild(elNode);
  }
  var instance = new _vue2.default(component).$mount(el);
  return {
    open: function open() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var propsLegal = Object.keys(props).every(function (propKey) {
        if (!component.props.hasOwnProperty(propKey)) {
          throw 'component has no prop ' + propKey;
          return false;
        } else {
          instance[propKey] = props[propKey];
          return true;
        }
      });
      if (!propsLegal) {
        return;
      }
      instance[visibleProp] = true; // open the component instance
      return new Promise(function (resolve, reject) {
        var rej = function rej(data) {
          instance[visibleProp] = false;
          reject(data);
        };
        linkEventsAndPromise(instance, resolveEvents, resolve);
        linkEventsAndPromise(instance, rejectEvents, rej);
      });
    },
    close: function close() {
      instance[visibleProp] = false;
    }
  };
};