import Vue from 'vue'
var linkEventsAndPromise = (instance, eventsList, type) => {
  eventsList.forEach(v => {
    instance.$on(v, function(data) {
      type({
        type: v,
        data
      })
    })
  })
}
export default (opt) => {
  var { component, resolveEvents = [], rejectEvents = [], el, visibleProp = 'visible' } = opt
  if (!el) {
    el = `#PC-EL-${new Date().getTime()}`
    var elNode = document.createElement('div')
    elNode.id = el.slice(1)
    document.body.appendChild(elNode)
  }
  var instance = new Vue(component).$mount(el)
  return {
    open(props = {}) {
      var propsLegal = Object.keys(props).every((propKey) => {
        if (!component.props.hasOwnProperty(propKey)) {
          throw 'component has no prop ' + propKey
          return false
        } else {
          instance[propKey] = props[propKey]
          return true
        }
      })
      if (!propsLegal) {
        return
      }
      instance[visibleProp] = true // open the component instance
      return new Promise((resolve, reject) => {
        var rej = (data) => {
          instance[visibleProp] = false
          reject(data)
        }
        linkEventsAndPromise(instance, resolveEvents, resolve)
        linkEventsAndPromise(instance, rejectEvents, rej)
      })
    },
    close() {
      instance[visibleProp] = false
    },
  }
}